#include <iostream>

template<typename T>
void func(T&& param) {
    if constexpr (std::is_lvalue_reference<T>::value) {
        std::cout << "param is an lvalue reference\n";
    } else {
        std::cout << "param is an rvalue reference\n";
    }
}

int main() {
    int x = 42;
    func(x);          // x is an lvalue, so T deduces to int&
    func(42);         // 42 is an rvalue, so T deduces to int

    return 0;
}

