#include <iostream>

// Rvalue reference
void rvalueRef(int&& param) {
    std::cout << "Rvalue reference\n";
}

// Universal reference
template<typename T>
void universalRef(T&& param) {
    std::cout << "Universal reference\n";
}

int main() {
    int x = 42;

    // rvalueRef(x);  // Error: x is an lvalue
    rvalueRef(42);    // OK: 42 is an rvalue

    universalRef(x);  // OK: x is an lvalue
    universalRef(42); // OK: 42 is an rvalue

    return 0;
}

